/* DateTime.c generated by valac 0.56.14, the Vala compiler
 * generated from DateTime.vala, do not modify */

/*
 * Copyright 2011-2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "elementary-calendar.h"
#include <glib.h>
#include <libical-glib/libical-glib.h>
#include <float.h>
#include <math.h>

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

gboolean
calendar_util_datetime_equal_func (GDateTime* a,
                                   GDateTime* b)
{
	gboolean result;
#line 25 "../core/Services/Calendar/Util/DateTime.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 25 "../core/Services/Calendar/Util/DateTime.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 26 "../core/Services/Calendar/Util/DateTime.vala"
	result = g_date_time_equal (a, b);
#line 26 "../core/Services/Calendar/Util/DateTime.vala"
	return result;
#line 45 "DateTime.c"
}

/**
     * Say if an event lasts all day.
     *
     * An all-day event is represented as both starting and ending at midnight
     * local time, so its duration is exactly a multiple of 24 hours.
     */
gboolean
calendar_util_datetime_is_all_day (GDateTime* dtstart,
                                   GDateTime* dtend)
{
	GTimeSpan timespan = 0LL;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 35 "../core/Services/Calendar/Util/DateTime.vala"
	g_return_val_if_fail (dtstart != NULL, FALSE);
#line 35 "../core/Services/Calendar/Util/DateTime.vala"
	g_return_val_if_fail (dtend != NULL, FALSE);
#line 36 "../core/Services/Calendar/Util/DateTime.vala"
	timespan = g_date_time_difference (dtend, dtstart);
#line 38 "../core/Services/Calendar/Util/DateTime.vala"
	if ((timespan % G_TIME_SPAN_DAY) == ((GTimeSpan) 0)) {
#line 38 "../core/Services/Calendar/Util/DateTime.vala"
		_tmp0_ = g_date_time_get_hour (dtstart) == 0;
#line 71 "DateTime.c"
	} else {
#line 38 "../core/Services/Calendar/Util/DateTime.vala"
		_tmp0_ = FALSE;
#line 75 "DateTime.c"
	}
#line 38 "../core/Services/Calendar/Util/DateTime.vala"
	if (_tmp0_) {
#line 39 "../core/Services/Calendar/Util/DateTime.vala"
		result = TRUE;
#line 39 "../core/Services/Calendar/Util/DateTime.vala"
		return result;
#line 83 "DateTime.c"
	} else {
#line 41 "../core/Services/Calendar/Util/DateTime.vala"
		result = FALSE;
#line 41 "../core/Services/Calendar/Util/DateTime.vala"
		return result;
#line 89 "DateTime.c"
	}
}

/**
     * Converts two DateTimes representing a date and a time to one TimeType.
     *
     * The first contains the date; its time settings are ignored. The second
     * one contains the time itself; its date settings are ignored. If the time
     * is `null`, the resulting TimeType is of `DATE` type; if it is given, the
     * TimeType is of `DATE-TIME` type.
     *
     * This also accepts an optional `timezone` argument. If it is given a
     * timezone, the resulting TimeType will be relative to the given timezone.
     * If it is `null`, the resulting TimeType will be "floating" with no
     * timezone. If the argument is not given, it will default to the system
     * timezone.
     */
ICalTime*
calendar_util_datetimes_to_icaltime (GDateTime* date,
                                     GDateTime* time_local,
                                     ICalTimezone* timezone)
{
	ICalTime* _result_ = NULL;
	ICalTime* _tmp0_;
	ICalTime* result;
#line 59 "../core/Services/Calendar/Util/DateTime.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 62 "../core/Services/Calendar/Util/DateTime.vala"
	_tmp0_ = i_cal_time_new_from_day_of_year (g_date_time_get_day_of_year (date), g_date_time_get_year (date));
#line 62 "../core/Services/Calendar/Util/DateTime.vala"
	_result_ = _tmp0_;
#line 68 "../core/Services/Calendar/Util/DateTime.vala"
	if (time_local == NULL) {
#line 123 "DateTime.c"
		ICalTime* _tmp1_;
		ICalTime* _tmp2_;
#line 70 "../core/Services/Calendar/Util/DateTime.vala"
		_tmp1_ = _result_;
#line 70 "../core/Services/Calendar/Util/DateTime.vala"
		i_cal_time_set_is_date (_tmp1_, TRUE);
#line 71 "../core/Services/Calendar/Util/DateTime.vala"
		_tmp2_ = _result_;
#line 71 "../core/Services/Calendar/Util/DateTime.vala"
		i_cal_time_set_time (_tmp2_, 0, 0, 0);
#line 134 "DateTime.c"
	} else {
		ICalTime* _tmp3_;
		ICalTime* _tmp4_;
		ICalTime* _tmp5_;
#line 75 "../core/Services/Calendar/Util/DateTime.vala"
		_tmp3_ = _result_;
#line 75 "../core/Services/Calendar/Util/DateTime.vala"
		i_cal_time_set_is_date (_tmp3_, FALSE);
#line 79 "../core/Services/Calendar/Util/DateTime.vala"
		_tmp4_ = _result_;
#line 79 "../core/Services/Calendar/Util/DateTime.vala"
		i_cal_time_set_timezone (_tmp4_, timezone);
#line 82 "../core/Services/Calendar/Util/DateTime.vala"
		_tmp5_ = _result_;
#line 82 "../core/Services/Calendar/Util/DateTime.vala"
		i_cal_time_set_time (_tmp5_, g_date_time_get_hour (time_local), g_date_time_get_minute (time_local), g_date_time_get_second (time_local));
#line 151 "DateTime.c"
	}
#line 85 "../core/Services/Calendar/Util/DateTime.vala"
	result = _result_;
#line 85 "../core/Services/Calendar/Util/DateTime.vala"
	return result;
#line 157 "DateTime.c"
}

/** Gets the start of the month that contains the given date
     *
     * Returns midnight (00:00) on that date.
     */
GDateTime*
calendar_util_datetime_get_start_of_month (GDateTime* date)
{
	GDateTime* _tmp1_;
	GDateTime* result;
#line 93 "../core/Services/Calendar/Util/DateTime.vala"
	if (date == NULL) {
#line 171 "DateTime.c"
		GDateTime* _tmp0_;
#line 94 "../core/Services/Calendar/Util/DateTime.vala"
		_tmp0_ = g_date_time_new_now_local ();
#line 94 "../core/Services/Calendar/Util/DateTime.vala"
		_g_date_time_unref0 (date);
#line 94 "../core/Services/Calendar/Util/DateTime.vala"
		date = _tmp0_;
#line 179 "DateTime.c"
	}
#line 97 "../core/Services/Calendar/Util/DateTime.vala"
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), 1, 0, 0, (gdouble) 0);
#line 97 "../core/Services/Calendar/Util/DateTime.vala"
	result = _tmp1_;
#line 97 "../core/Services/Calendar/Util/DateTime.vala"
	_g_date_time_unref0 (date);
#line 97 "../core/Services/Calendar/Util/DateTime.vala"
	return result;
#line 189 "DateTime.c"
}

GDateTime*
calendar_util_datetime_strip_time (GDateTime* datetime)
{
	GDateTime* _tmp0_;
	GDateTime* result;
#line 100 "../core/Services/Calendar/Util/DateTime.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 101 "../core/Services/Calendar/Util/DateTime.vala"
	_tmp0_ = g_date_time_add_full (datetime, 0, 0, 0, -g_date_time_get_hour (datetime), -g_date_time_get_minute (datetime), (gdouble) (-g_date_time_get_second (datetime)));
#line 101 "../core/Services/Calendar/Util/DateTime.vala"
	result = _tmp0_;
#line 101 "../core/Services/Calendar/Util/DateTime.vala"
	return result;
#line 205 "DateTime.c"
}

