/* ICalComponent.c generated by valac 0.56.14, the Vala compiler
 * generated from ICalComponent.vala, do not modify */

/*
 * Copyright 2011-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "elementary-calendar.h"
#include <libical-glib/libical-glib.h>
#include <glib.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

/** Gets the start and end times of @component as {@link ICal.Time} objects.
     * 
     * This accounts for implicit end times by calculating its value from a
     * duration, if necessary.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "../core/Services/Calendar/Util/ICalComponent.vala"
	return self ? g_object_ref (self) : NULL;
#line 41 "ICalComponent.c"
}

void
calendar_util_icalcomponent_get_icaltimes (ICalComponent* component,
                                           ICalTime** dt_start,
                                           ICalTime** dt_end)
{
	ICalTime* _vala_dt_start = NULL;
	ICalTime* _vala_dt_end = NULL;
	ICalTime* _tmp0_;
	ICalTime* _tmp1_;
	ICalTime* _tmp2_;
#line 29 "../core/Services/Calendar/Util/ICalComponent.vala"
	g_return_if_fail (component != NULL);
#line 30 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp0_ = i_cal_component_get_dtstart (component);
#line 30 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_object_unref0 (_vala_dt_start);
#line 30 "../core/Services/Calendar/Util/ICalComponent.vala"
	_vala_dt_start = _tmp0_;
#line 31 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp1_ = i_cal_component_get_dtend (component);
#line 31 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_object_unref0 (_vala_dt_end);
#line 31 "../core/Services/Calendar/Util/ICalComponent.vala"
	_vala_dt_end = _tmp1_;
#line 34 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp2_ = _vala_dt_end;
#line 34 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (i_cal_time_is_null_time (_tmp2_)) {
#line 72 "ICalComponent.c"
		ICalDuration* _tmp3_;
		ICalDuration* _tmp4_;
		gboolean _tmp5_;
#line 35 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp3_ = i_cal_component_get_duration (component);
#line 35 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp4_ = _tmp3_;
#line 35 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp5_ = !i_cal_duration_is_null_duration (_tmp4_);
#line 35 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_object_unref0 (_tmp4_);
#line 35 "../core/Services/Calendar/Util/ICalComponent.vala"
		if (_tmp5_) {
#line 86 "ICalComponent.c"
			ICalTime* _tmp6_;
			ICalDuration* _tmp7_;
			ICalDuration* _tmp8_;
			ICalTime* _tmp9_;
#line 37 "../core/Services/Calendar/Util/ICalComponent.vala"
			_tmp6_ = _vala_dt_start;
#line 37 "../core/Services/Calendar/Util/ICalComponent.vala"
			_tmp7_ = i_cal_component_get_duration (component);
#line 37 "../core/Services/Calendar/Util/ICalComponent.vala"
			_tmp8_ = _tmp7_;
#line 37 "../core/Services/Calendar/Util/ICalComponent.vala"
			_tmp9_ = i_cal_time_add (_tmp6_, _tmp8_);
#line 37 "../core/Services/Calendar/Util/ICalComponent.vala"
			_g_object_unref0 (_vala_dt_end);
#line 37 "../core/Services/Calendar/Util/ICalComponent.vala"
			_vala_dt_end = _tmp9_;
#line 37 "../core/Services/Calendar/Util/ICalComponent.vala"
			_g_object_unref0 (_tmp8_);
#line 105 "ICalComponent.c"
		} else {
			ICalTime* _tmp10_;
#line 38 "../core/Services/Calendar/Util/ICalComponent.vala"
			_tmp10_ = _vala_dt_start;
#line 38 "../core/Services/Calendar/Util/ICalComponent.vala"
			if (i_cal_time_is_date (_tmp10_)) {
#line 112 "ICalComponent.c"
				ICalTime* _tmp11_;
				ICalTime* _tmp12_;
				ICalTime* _tmp13_;
#line 40 "../core/Services/Calendar/Util/ICalComponent.vala"
				_tmp11_ = _vala_dt_start;
#line 40 "../core/Services/Calendar/Util/ICalComponent.vala"
				_tmp12_ = i_cal_time_clone (_tmp11_);
#line 40 "../core/Services/Calendar/Util/ICalComponent.vala"
				_g_object_unref0 (_vala_dt_end);
#line 40 "../core/Services/Calendar/Util/ICalComponent.vala"
				_vala_dt_end = _tmp12_;
#line 41 "../core/Services/Calendar/Util/ICalComponent.vala"
				_tmp13_ = _vala_dt_end;
#line 41 "../core/Services/Calendar/Util/ICalComponent.vala"
				i_cal_time_adjust (_tmp13_, 1, 0, 0, 0);
#line 128 "ICalComponent.c"
			} else {
				ICalTime* _tmp14_;
				ICalTime* _tmp15_;
#line 44 "../core/Services/Calendar/Util/ICalComponent.vala"
				_tmp14_ = _vala_dt_start;
#line 44 "../core/Services/Calendar/Util/ICalComponent.vala"
				_tmp15_ = _g_object_ref0 (_tmp14_);
#line 44 "../core/Services/Calendar/Util/ICalComponent.vala"
				_g_object_unref0 (_vala_dt_end);
#line 44 "../core/Services/Calendar/Util/ICalComponent.vala"
				_vala_dt_end = _tmp15_;
#line 140 "ICalComponent.c"
			}
		}
	}
#line 29 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (dt_start) {
#line 29 "../core/Services/Calendar/Util/ICalComponent.vala"
		*dt_start = _vala_dt_start;
#line 148 "ICalComponent.c"
	} else {
#line 29 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_object_unref0 (_vala_dt_start);
#line 152 "ICalComponent.c"
	}
#line 29 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (dt_end) {
#line 29 "../core/Services/Calendar/Util/ICalComponent.vala"
		*dt_end = _vala_dt_end;
#line 158 "ICalComponent.c"
	} else {
#line 29 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_object_unref0 (_vala_dt_end);
#line 162 "ICalComponent.c"
	}
}

/** Gets a pair of {@link GLib.DateTime} objects representing the start and
     *  end of the given component, represented in the system time zone.
     *
     * The conversion behavior differs based on the type of {@link ICal.Time}.
     * DATE type times (which contain no time information) are represented as
     * midnight on the given date in the local timezone
     * (see {@link Calendar.Util.datetime_is_all_day}).
     * DATE-TIME type times are converted to the local timezone if they have
     * a time zone, and are represented at the given time in the local timezone
     * if they are floating.
     *
     * Note that unlike {@link icalcomponent_get_datetimes}, the
     * {@link GLib.TimeZone} contained in @start_date and @end_date is
     * guaranteed to be correct, since there is a well-defined local timezone
     * between both libical and GLib. For
     * more details, see {@link Calendar.Util.icaltime_to_local_datetime}.
     *
     * @see icalcomponent_get_datetimes
     */
void
calendar_util_icalcomponent_get_local_datetimes (ICalComponent* component,
                                                 GDateTime** start_date,
                                                 GDateTime** end_date)
{
	GDateTime* _vala_start_date = NULL;
	GDateTime* _vala_end_date = NULL;
	ICalTime* dt_start = NULL;
	ICalTime* dt_end = NULL;
	ICalTime* _tmp0_ = NULL;
	ICalTime* _tmp1_ = NULL;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
#line 68 "../core/Services/Calendar/Util/ICalComponent.vala"
	g_return_if_fail (component != NULL);
#line 71 "../core/Services/Calendar/Util/ICalComponent.vala"
	calendar_util_icalcomponent_get_icaltimes (component, &_tmp0_, &_tmp1_);
#line 71 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_object_unref0 (dt_start);
#line 71 "../core/Services/Calendar/Util/ICalComponent.vala"
	dt_start = _tmp0_;
#line 71 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_object_unref0 (dt_end);
#line 71 "../core/Services/Calendar/Util/ICalComponent.vala"
	dt_end = _tmp1_;
#line 73 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp2_ = calendar_util_icaltime_to_local_datetime (dt_start);
#line 73 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (_vala_start_date);
#line 73 "../core/Services/Calendar/Util/ICalComponent.vala"
	_vala_start_date = _tmp2_;
#line 74 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp3_ = calendar_util_icaltime_to_local_datetime (dt_end);
#line 74 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (_vala_end_date);
#line 74 "../core/Services/Calendar/Util/ICalComponent.vala"
	_vala_end_date = _tmp3_;
#line 68 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_object_unref0 (dt_end);
#line 68 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_object_unref0 (dt_start);
#line 68 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (start_date) {
#line 68 "../core/Services/Calendar/Util/ICalComponent.vala"
		*start_date = _vala_start_date;
#line 230 "ICalComponent.c"
	} else {
#line 68 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (_vala_start_date);
#line 234 "ICalComponent.c"
	}
#line 68 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (end_date) {
#line 68 "../core/Services/Calendar/Util/ICalComponent.vala"
		*end_date = _vala_end_date;
#line 240 "ICalComponent.c"
	} else {
#line 68 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (_vala_end_date);
#line 244 "ICalComponent.c"
	}
}

/** Gets a pair of {@link GLib.DateTime} objects representing the start and
     *  end of the given component, represented in the time zone of @component.
     *
     * **Note:** the {@link GLib.TimeZone} data of @start_date and @end_date
     * is not guaranteed to be correct. You should never assume that the time
     * zone data contained in the resulting objects is correct. The intention
     * is that all time zone calculations should be done in libical directly,
     * where time zone data should be correct. This is because it's not
     * always possible to map a libical timezone to a GLib timezone. For
     * more details, see {@link Calendar.Util.icaltime_to_datetime}.
     *
     * @see icalcomponent_get_local_datetimes
     */
void
calendar_util_icalcomponent_get_datetimes (ICalComponent* component,
                                           GDateTime** start_date,
                                           GDateTime** end_date)
{
	GDateTime* _vala_start_date = NULL;
	GDateTime* _vala_end_date = NULL;
	ICalTime* dt_start = NULL;
	ICalTime* dt_end = NULL;
	ICalTime* _tmp0_ = NULL;
	ICalTime* _tmp1_ = NULL;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
#line 90 "../core/Services/Calendar/Util/ICalComponent.vala"
	g_return_if_fail (component != NULL);
#line 93 "../core/Services/Calendar/Util/ICalComponent.vala"
	calendar_util_icalcomponent_get_icaltimes (component, &_tmp0_, &_tmp1_);
#line 93 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_object_unref0 (dt_start);
#line 93 "../core/Services/Calendar/Util/ICalComponent.vala"
	dt_start = _tmp0_;
#line 93 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_object_unref0 (dt_end);
#line 93 "../core/Services/Calendar/Util/ICalComponent.vala"
	dt_end = _tmp1_;
#line 95 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp2_ = calendar_util_icaltime_to_datetime (dt_start);
#line 95 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (_vala_start_date);
#line 95 "../core/Services/Calendar/Util/ICalComponent.vala"
	_vala_start_date = _tmp2_;
#line 96 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp3_ = calendar_util_icaltime_to_datetime (dt_end);
#line 96 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (_vala_end_date);
#line 96 "../core/Services/Calendar/Util/ICalComponent.vala"
	_vala_end_date = _tmp3_;
#line 90 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_object_unref0 (dt_end);
#line 90 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_object_unref0 (dt_start);
#line 90 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (start_date) {
#line 90 "../core/Services/Calendar/Util/ICalComponent.vala"
		*start_date = _vala_start_date;
#line 306 "ICalComponent.c"
	} else {
#line 90 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (_vala_start_date);
#line 310 "ICalComponent.c"
	}
#line 90 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (end_date) {
#line 90 "../core/Services/Calendar/Util/ICalComponent.vala"
		*end_date = _vala_end_date;
#line 316 "ICalComponent.c"
	} else {
#line 90 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (_vala_end_date);
#line 320 "ICalComponent.c"
	}
}

/** Wraps {@link icalcomponent_get_local_datetimes()}, including date
     *  adjustments for all-day events.
     *
     * Like {@link icalcomponent_get_local_datetimes()}, this gets a pair of
     * {@link GLib.DateTime} objects representing the start and end of the
     * given component.
     *
     * It differs in its handling of all-day events. According to
     * RFC 5545, their end time is exclusive, representing the day after the
     * last day the event occurs. To handle this, we must "fake" an earlier
     * date to replicate the expected experience of an inclusive end date.
     * It substracts a single day from the end time of all-day events. It leaves
     * other events unchanged.
     *
     * This should be used for user-facing display only. It breaks from spec to
     * make the display of all-day events more intuitive, and doesn't reflect
     * the actual times the events occur.
     *
     * This converts the resulting times to the local timezone. If you want to keep
     * the result in @component's timezone, use {@link icalcmponent_get_datetimes_for_display}.
     */
void
calendar_util_icalcomponent_get_local_datetimes_for_display (ICalComponent* component,
                                                             GDateTime** start_date,
                                                             GDateTime** end_date)
{
	GDateTime* _vala_start_date = NULL;
	GDateTime* _vala_end_date = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
#line 120 "../core/Services/Calendar/Util/ICalComponent.vala"
	g_return_if_fail (component != NULL);
#line 121 "../core/Services/Calendar/Util/ICalComponent.vala"
	calendar_util_icalcomponent_get_local_datetimes (component, &_tmp0_, &_tmp1_);
#line 121 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (_vala_start_date);
#line 121 "../core/Services/Calendar/Util/ICalComponent.vala"
	_vala_start_date = _tmp0_;
#line 121 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (_vala_end_date);
#line 121 "../core/Services/Calendar/Util/ICalComponent.vala"
	_vala_end_date = _tmp1_;
#line 123 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp2_ = _vala_start_date;
#line 123 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp3_ = _vala_end_date;
#line 123 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (calendar_util_datetime_is_all_day (_tmp2_, _tmp3_)) {
#line 374 "ICalComponent.c"
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
#line 124 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp4_ = _vala_end_date;
#line 124 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp5_ = g_date_time_add_days (_tmp4_, -1);
#line 124 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (_vala_end_date);
#line 124 "../core/Services/Calendar/Util/ICalComponent.vala"
		_vala_end_date = _tmp5_;
#line 385 "ICalComponent.c"
	}
#line 120 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (start_date) {
#line 120 "../core/Services/Calendar/Util/ICalComponent.vala"
		*start_date = _vala_start_date;
#line 391 "ICalComponent.c"
	} else {
#line 120 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (_vala_start_date);
#line 395 "ICalComponent.c"
	}
#line 120 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (end_date) {
#line 120 "../core/Services/Calendar/Util/ICalComponent.vala"
		*end_date = _vala_end_date;
#line 401 "ICalComponent.c"
	} else {
#line 120 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (_vala_end_date);
#line 405 "ICalComponent.c"
	}
}

/** Wraps {@link icalcomponent_get_datetimes()}, including date
     *  adjustments for all-day events.
     *
     * Like {@link icalcomponent_get_datetimes()}, this gets a pair of
     * {@link GLib.DateTime} objects representing the start and end of the
     * given component.
     *
     * It differs in its handling of all-day events. According to
     * RFC 5545, their end time is exclusive, representing the day after the
     * last day the event occurs. To handle this, we must "fake" an earlier
     * date to replicate the expected experience of an inclusive end date.
     * It substracts a single day from the end time of all-day events. It leaves
     * other events unchanged.
     *
     * This should be used for user-facing display only. It breaks from spec to
     * make the display of all-day events more intuitive, and doesn't reflect
     * the actual times the events occur.
     *
     * This keeps the resulting times in @component's timezone. If you want to convert
     * the result to local time, use {@link icalcmponent_get_local_datetimes_for_display}.
     */
void
calendar_util_icalcomponent_get_datetimes_for_display (ICalComponent* component,
                                                       GDateTime** start_date,
                                                       GDateTime** end_date)
{
	GDateTime* _vala_start_date = NULL;
	GDateTime* _vala_end_date = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
#line 149 "../core/Services/Calendar/Util/ICalComponent.vala"
	g_return_if_fail (component != NULL);
#line 150 "../core/Services/Calendar/Util/ICalComponent.vala"
	calendar_util_icalcomponent_get_datetimes (component, &_tmp0_, &_tmp1_);
#line 150 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (_vala_start_date);
#line 150 "../core/Services/Calendar/Util/ICalComponent.vala"
	_vala_start_date = _tmp0_;
#line 150 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (_vala_end_date);
#line 150 "../core/Services/Calendar/Util/ICalComponent.vala"
	_vala_end_date = _tmp1_;
#line 152 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp2_ = _vala_start_date;
#line 152 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp3_ = _vala_end_date;
#line 152 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (calendar_util_datetime_is_all_day (_tmp2_, _tmp3_)) {
#line 459 "ICalComponent.c"
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
#line 153 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp4_ = _vala_end_date;
#line 153 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp5_ = g_date_time_add_days (_tmp4_, -1);
#line 153 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (_vala_end_date);
#line 153 "../core/Services/Calendar/Util/ICalComponent.vala"
		_vala_end_date = _tmp5_;
#line 470 "ICalComponent.c"
	}
#line 149 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (start_date) {
#line 149 "../core/Services/Calendar/Util/ICalComponent.vala"
		*start_date = _vala_start_date;
#line 476 "ICalComponent.c"
	} else {
#line 149 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (_vala_start_date);
#line 480 "ICalComponent.c"
	}
#line 149 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (end_date) {
#line 149 "../core/Services/Calendar/Util/ICalComponent.vala"
		*end_date = _vala_end_date;
#line 486 "ICalComponent.c"
	} else {
#line 149 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (_vala_end_date);
#line 490 "ICalComponent.c"
	}
}

/** Returns whether the given icalcomponent overlaps with the time range.
     *
     * This is true if the icalcomponent either starts or ends within the range, even
     * if the entire icalcomponent doesn't happen within the range.
     */
gboolean
calendar_util_icalcomponent_is_in_range (ICalComponent* component,
                                         CalendarUtilDateRange* range)
{
	GDateTime* start = NULL;
	GDateTime* end = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
	gint c1 = 0;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	gint c2 = 0;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	gint c3 = 0;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	GDateTime* _tmp10_;
	gint c4 = 0;
	GDateTime* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean result;
#line 162 "../core/Services/Calendar/Util/ICalComponent.vala"
	g_return_val_if_fail (component != NULL, FALSE);
#line 162 "../core/Services/Calendar/Util/ICalComponent.vala"
	g_return_val_if_fail (range != NULL, FALSE);
#line 164 "../core/Services/Calendar/Util/ICalComponent.vala"
	calendar_util_icalcomponent_get_local_datetimes (component, &_tmp0_, &_tmp1_);
#line 164 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (start);
#line 164 "../core/Services/Calendar/Util/ICalComponent.vala"
	start = _tmp0_;
#line 164 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (end);
#line 164 "../core/Services/Calendar/Util/ICalComponent.vala"
	end = _tmp1_;
#line 166 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp2_ = start;
#line 166 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp3_ = calendar_util_date_range_get_first_dt (range);
#line 166 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp4_ = _tmp3_;
#line 166 "../core/Services/Calendar/Util/ICalComponent.vala"
	c1 = g_date_time_compare (_tmp2_, _tmp4_);
#line 167 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp5_ = start;
#line 167 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp6_ = calendar_util_date_range_get_last_dt (range);
#line 167 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp7_ = _tmp6_;
#line 167 "../core/Services/Calendar/Util/ICalComponent.vala"
	c2 = g_date_time_compare (_tmp5_, _tmp7_);
#line 168 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp8_ = end;
#line 168 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp9_ = calendar_util_date_range_get_first_dt (range);
#line 168 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp10_ = _tmp9_;
#line 168 "../core/Services/Calendar/Util/ICalComponent.vala"
	c3 = g_date_time_compare (_tmp8_, _tmp10_);
#line 169 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp11_ = end;
#line 169 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp12_ = calendar_util_date_range_get_last_dt (range);
#line 169 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp13_ = _tmp12_;
#line 169 "../core/Services/Calendar/Util/ICalComponent.vala"
	c4 = g_date_time_compare (_tmp11_, _tmp13_);
#line 171 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (c1 <= 0) {
#line 171 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp14_ = c3 > 0;
#line 578 "ICalComponent.c"
	} else {
#line 171 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp14_ = FALSE;
#line 582 "ICalComponent.c"
	}
#line 171 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (_tmp14_) {
#line 172 "../core/Services/Calendar/Util/ICalComponent.vala"
		result = TRUE;
#line 172 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (end);
#line 172 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (start);
#line 172 "../core/Services/Calendar/Util/ICalComponent.vala"
		return result;
#line 594 "ICalComponent.c"
	}
#line 174 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (c2 < 0) {
#line 174 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp15_ = c4 > 0;
#line 600 "ICalComponent.c"
	} else {
#line 174 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp15_ = FALSE;
#line 604 "ICalComponent.c"
	}
#line 174 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (_tmp15_) {
#line 175 "../core/Services/Calendar/Util/ICalComponent.vala"
		result = TRUE;
#line 175 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (end);
#line 175 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (start);
#line 175 "../core/Services/Calendar/Util/ICalComponent.vala"
		return result;
#line 616 "ICalComponent.c"
	}
#line 177 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (c1 >= 0) {
#line 177 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp16_ = c2 < 0;
#line 622 "ICalComponent.c"
	} else {
#line 177 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp16_ = FALSE;
#line 626 "ICalComponent.c"
	}
#line 177 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (_tmp16_) {
#line 178 "../core/Services/Calendar/Util/ICalComponent.vala"
		result = TRUE;
#line 178 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (end);
#line 178 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (start);
#line 178 "../core/Services/Calendar/Util/ICalComponent.vala"
		return result;
#line 638 "ICalComponent.c"
	}
#line 180 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (c3 > 0) {
#line 180 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp17_ = c4 < 0;
#line 644 "ICalComponent.c"
	} else {
#line 180 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp17_ = FALSE;
#line 648 "ICalComponent.c"
	}
#line 180 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (_tmp17_) {
#line 181 "../core/Services/Calendar/Util/ICalComponent.vala"
		result = TRUE;
#line 181 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (end);
#line 181 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (start);
#line 181 "../core/Services/Calendar/Util/ICalComponent.vala"
		return result;
#line 660 "ICalComponent.c"
	}
#line 184 "../core/Services/Calendar/Util/ICalComponent.vala"
	result = FALSE;
#line 184 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (end);
#line 184 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (start);
#line 184 "../core/Services/Calendar/Util/ICalComponent.vala"
	return result;
#line 670 "ICalComponent.c"
}

gboolean
calendar_util_icalcomponent_is_multiday (ICalComponent* component)
{
	GDateTime* start = NULL;
	GDateTime* end = NULL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	gboolean result;
#line 187 "../core/Services/Calendar/Util/ICalComponent.vala"
	g_return_val_if_fail (component != NULL, FALSE);
#line 189 "../core/Services/Calendar/Util/ICalComponent.vala"
	calendar_util_icalcomponent_get_local_datetimes_for_display (component, &_tmp0_, &_tmp1_);
#line 189 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (start);
#line 189 "../core/Services/Calendar/Util/ICalComponent.vala"
	start = _tmp0_;
#line 189 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (end);
#line 189 "../core/Services/Calendar/Util/ICalComponent.vala"
	end = _tmp1_;
#line 191 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp3_ = start;
#line 191 "../core/Services/Calendar/Util/ICalComponent.vala"
	_tmp4_ = end;
#line 191 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (g_date_time_get_year (_tmp3_) != g_date_time_get_year (_tmp4_)) {
#line 191 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp2_ = TRUE;
#line 704 "ICalComponent.c"
	} else {
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
#line 191 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp5_ = start;
#line 191 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp6_ = end;
#line 191 "../core/Services/Calendar/Util/ICalComponent.vala"
		_tmp2_ = g_date_time_get_day_of_year (_tmp5_) != g_date_time_get_day_of_year (_tmp6_);
#line 714 "ICalComponent.c"
	}
#line 191 "../core/Services/Calendar/Util/ICalComponent.vala"
	if (_tmp2_) {
#line 192 "../core/Services/Calendar/Util/ICalComponent.vala"
		result = TRUE;
#line 192 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (end);
#line 192 "../core/Services/Calendar/Util/ICalComponent.vala"
		_g_date_time_unref0 (start);
#line 192 "../core/Services/Calendar/Util/ICalComponent.vala"
		return result;
#line 726 "ICalComponent.c"
	}
#line 194 "../core/Services/Calendar/Util/ICalComponent.vala"
	result = FALSE;
#line 194 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (end);
#line 194 "../core/Services/Calendar/Util/ICalComponent.vala"
	_g_date_time_unref0 (start);
#line 194 "../core/Services/Calendar/Util/ICalComponent.vala"
	return result;
#line 736 "ICalComponent.c"
}

