/* GoogleBackend.c generated by valac 0.56.14, the Vala compiler
 * generated from GoogleBackend.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013 Maya Developers (https://launchpad.net/maya)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <tintou@mailoo.org>
 */

#include "google.h"
#include <gmodule.h>
#include "elementary-calendar.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <libedataserver/libedataserver.h>
#include <gee.h>
#include <gtk/gtk.h>

enum  {
	MAYA_GOOGLE_BACKEND_0_PROPERTY,
	MAYA_GOOGLE_BACKEND_NUM_PROPERTIES
};
static GParamSpec* maya_google_backend_properties[MAYA_GOOGLE_BACKEND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

MayaBackend* backend = NULL;
static gpointer maya_google_backend_parent_class = NULL;
static MayaBackendIface * maya_google_backend_maya_backend_parent_iface = NULL;

static gchar* maya_google_backend_real_get_name (MayaBackend* base);
static gchar* maya_google_backend_real_get_uid (MayaBackend* base);
static GeeCollection* maya_google_backend_real_get_new_calendar_widget (MayaBackend* base,
                                                                 ESource* to_edit);
static void maya_google_backend_real_add_new_calendar (MayaBackend* base,
                                                const gchar* name,
                                                const gchar* color,
                                                gboolean set_default,
                                                GeeCollection* widgets);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void maya_google_backend_real_modify_calendar (MayaBackend* base,
                                               const gchar* name,
                                               const gchar* color,
                                               gboolean set_default,
                                               GeeCollection* widgets,
                                               ESource* source);
static GType maya_google_backend_get_type_once (void);

MayaBackend*
get_backend (GModule* module)
{
	MayaGoogleBackend* b = NULL;
	MayaGoogleBackend* _tmp0_;
	MayaBackend* result;
#line 23 "../plugins/Google/GoogleBackend.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 24 "../plugins/Google/GoogleBackend.vala"
	g_debug ("GoogleBackend.vala:24: Activating Google Backend");
#line 25 "../plugins/Google/GoogleBackend.vala"
	_tmp0_ = maya_google_backend_new ();
#line 25 "../plugins/Google/GoogleBackend.vala"
	b = _tmp0_;
#line 26 "../plugins/Google/GoogleBackend.vala"
	g_object_ref ((GObject*) b);
#line 27 "../plugins/Google/GoogleBackend.vala"
	result = (MayaBackend*) b;
#line 27 "../plugins/Google/GoogleBackend.vala"
	return result;
#line 92 "GoogleBackend.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 34 "../plugins/Google/GoogleBackend.vala"
	return self ? g_object_ref (self) : NULL;
#line 100 "GoogleBackend.c"
}

MayaGoogleBackend*
maya_google_backend_construct (GType object_type)
{
	MayaGoogleBackend * self = NULL;
	MayaBackend* _tmp0_;
#line 33 "../plugins/Google/GoogleBackend.vala"
	self = (MayaGoogleBackend*) g_object_new (object_type, NULL);
#line 34 "../plugins/Google/GoogleBackend.vala"
	_tmp0_ = _g_object_ref0 ((MayaBackend*) self);
#line 34 "../plugins/Google/GoogleBackend.vala"
	_g_object_unref0 (backend);
#line 34 "../plugins/Google/GoogleBackend.vala"
	backend = _tmp0_;
#line 33 "../plugins/Google/GoogleBackend.vala"
	return self;
#line 118 "GoogleBackend.c"
}

MayaGoogleBackend*
maya_google_backend_new (void)
{
#line 33 "../plugins/Google/GoogleBackend.vala"
	return maya_google_backend_construct (MAYA_TYPE_GOOGLE_BACKEND);
#line 126 "GoogleBackend.c"
}

static gchar*
maya_google_backend_real_get_name (MayaBackend* base)
{
	MayaGoogleBackend * self;
	gchar* _tmp0_;
	gchar* result;
#line 37 "../plugins/Google/GoogleBackend.vala"
	self = (MayaGoogleBackend*) base;
#line 38 "../plugins/Google/GoogleBackend.vala"
	_tmp0_ = g_strdup (_ ("Google"));
#line 38 "../plugins/Google/GoogleBackend.vala"
	result = _tmp0_;
#line 38 "../plugins/Google/GoogleBackend.vala"
	return result;
#line 143 "GoogleBackend.c"
}

static gchar*
maya_google_backend_real_get_uid (MayaBackend* base)
{
	MayaGoogleBackend * self;
	gchar* _tmp0_;
	gchar* result;
#line 41 "../plugins/Google/GoogleBackend.vala"
	self = (MayaGoogleBackend*) base;
#line 42 "../plugins/Google/GoogleBackend.vala"
	_tmp0_ = g_strdup ("google-stub");
#line 42 "../plugins/Google/GoogleBackend.vala"
	result = _tmp0_;
#line 42 "../plugins/Google/GoogleBackend.vala"
	return result;
#line 160 "GoogleBackend.c"
}

static GeeCollection*
maya_google_backend_real_get_new_calendar_widget (MayaBackend* base,
                                                  ESource* to_edit)
{
	MayaGoogleBackend * self;
	GeeLinkedList* collection = NULL;
	GeeLinkedList* _tmp0_;
	gboolean keep_copy = FALSE;
	GeeLinkedList* _tmp6_;
	MayaPlacementWidget* _tmp7_;
	MayaPlacementWidget* _tmp8_;
	gchar* user = NULL;
	gchar* _tmp9_;
	GeeLinkedList* _tmp16_;
	const gchar* _tmp17_;
	GeeLinkedList* _tmp18_;
	GeeLinkedList* _tmp19_;
	GeeCollection* result;
#line 45 "../plugins/Google/GoogleBackend.vala"
	self = (MayaGoogleBackend*) base;
#line 46 "../plugins/Google/GoogleBackend.vala"
	_tmp0_ = gee_linked_list_new (MAYA_TYPE_PLACEMENT_WIDGET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 46 "../plugins/Google/GoogleBackend.vala"
	collection = _tmp0_;
#line 48 "../plugins/Google/GoogleBackend.vala"
	keep_copy = FALSE;
#line 49 "../plugins/Google/GoogleBackend.vala"
	if (to_edit != NULL) {
#line 191 "GoogleBackend.c"
		ESourceOffline* source_offline = NULL;
		ESourceExtension* _tmp1_;
		ESourceOffline* _tmp2_;
		ESourceOffline* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 50 "../plugins/Google/GoogleBackend.vala"
		_tmp1_ = e_source_get_extension (to_edit, E_SOURCE_EXTENSION_OFFLINE);
#line 50 "../plugins/Google/GoogleBackend.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, e_source_offline_get_type (), ESourceOffline));
#line 50 "../plugins/Google/GoogleBackend.vala"
		source_offline = _tmp2_;
#line 51 "../plugins/Google/GoogleBackend.vala"
		_tmp3_ = source_offline;
#line 51 "../plugins/Google/GoogleBackend.vala"
		_tmp4_ = e_source_offline_get_stay_synchronized (_tmp3_);
#line 51 "../plugins/Google/GoogleBackend.vala"
		_tmp5_ = _tmp4_;
#line 51 "../plugins/Google/GoogleBackend.vala"
		keep_copy = _tmp5_;
#line 49 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (source_offline);
#line 214 "GoogleBackend.c"
	}
#line 53 "../plugins/Google/GoogleBackend.vala"
	_tmp6_ = collection;
#line 53 "../plugins/Google/GoogleBackend.vala"
	_tmp7_ = maya_default_placement_widgets_get_keep_copy (3, keep_copy);
#line 53 "../plugins/Google/GoogleBackend.vala"
	_tmp8_ = _tmp7_;
#line 53 "../plugins/Google/GoogleBackend.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp8_);
#line 53 "../plugins/Google/GoogleBackend.vala"
	_g_object_unref0 (_tmp8_);
#line 55 "../plugins/Google/GoogleBackend.vala"
	_tmp9_ = g_strdup ("");
#line 55 "../plugins/Google/GoogleBackend.vala"
	user = _tmp9_;
#line 56 "../plugins/Google/GoogleBackend.vala"
	if (to_edit != NULL) {
#line 232 "GoogleBackend.c"
		ESourceAuthentication* auth = NULL;
		ESourceExtension* _tmp10_;
		ESourceAuthentication* _tmp11_;
		ESourceAuthentication* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 57 "../plugins/Google/GoogleBackend.vala"
		_tmp10_ = e_source_get_extension (to_edit, E_SOURCE_EXTENSION_AUTHENTICATION);
#line 57 "../plugins/Google/GoogleBackend.vala"
		_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, e_source_authentication_get_type (), ESourceAuthentication));
#line 57 "../plugins/Google/GoogleBackend.vala"
		auth = _tmp11_;
#line 58 "../plugins/Google/GoogleBackend.vala"
		_tmp12_ = auth;
#line 58 "../plugins/Google/GoogleBackend.vala"
		_tmp13_ = e_source_authentication_get_user (_tmp12_);
#line 58 "../plugins/Google/GoogleBackend.vala"
		_tmp14_ = _tmp13_;
#line 58 "../plugins/Google/GoogleBackend.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 58 "../plugins/Google/GoogleBackend.vala"
		_g_free0 (user);
#line 58 "../plugins/Google/GoogleBackend.vala"
		user = _tmp15_;
#line 56 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (auth);
#line 260 "GoogleBackend.c"
	}
#line 61 "../plugins/Google/GoogleBackend.vala"
	_tmp16_ = collection;
#line 61 "../plugins/Google/GoogleBackend.vala"
	_tmp17_ = user;
#line 61 "../plugins/Google/GoogleBackend.vala"
	_tmp18_ = maya_default_placement_widgets_get_user (4, TRUE, _tmp17_, _ ("user.name or user.name@gmail.com"));
#line 61 "../plugins/Google/GoogleBackend.vala"
	_tmp19_ = _tmp18_;
#line 61 "../plugins/Google/GoogleBackend.vala"
	gee_collection_add_all ((GeeCollection*) _tmp16_, (GeeCollection*) _tmp19_);
#line 61 "../plugins/Google/GoogleBackend.vala"
	_g_object_unref0 (_tmp19_);
#line 63 "../plugins/Google/GoogleBackend.vala"
	result = (GeeCollection*) collection;
#line 63 "../plugins/Google/GoogleBackend.vala"
	_g_free0 (user);
#line 63 "../plugins/Google/GoogleBackend.vala"
	return result;
#line 280 "GoogleBackend.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 299 "GoogleBackend.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 116 "../plugins/Google/GoogleBackend.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 307 "GoogleBackend.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 116 "../plugins/Google/GoogleBackend.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 315 "GoogleBackend.c"
}

static void
maya_google_backend_real_add_new_calendar (MayaBackend* base,
                                           const gchar* name,
                                           const gchar* color,
                                           gboolean set_default,
                                           GeeCollection* widgets)
{
	MayaGoogleBackend * self;
	GError* _inner_error0_ = NULL;
#line 66 "../plugins/Google/GoogleBackend.vala"
	self = (MayaGoogleBackend*) base;
#line 66 "../plugins/Google/GoogleBackend.vala"
	g_return_if_fail (name != NULL);
#line 66 "../plugins/Google/GoogleBackend.vala"
	g_return_if_fail (color != NULL);
#line 66 "../plugins/Google/GoogleBackend.vala"
	g_return_if_fail (widgets != NULL);
#line 335 "GoogleBackend.c"
	{
		ESource* new_source = NULL;
		ESource* _tmp0_;
		ESource* _tmp1_;
		ESource* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		ESourceCalendar* cal = NULL;
		ESource* _tmp5_;
		ESourceExtension* _tmp6_;
		ESourceCalendar* _tmp7_;
		ESourceCalendar* _tmp8_;
		ESourceCalendar* _tmp9_;
		ESourceWebdav* webdav = NULL;
		ESource* _tmp10_;
		ESourceExtension* _tmp11_;
		ESourceWebdav* _tmp12_;
		ESourceOffline* offline = NULL;
		ESource* _tmp13_;
		ESourceExtension* _tmp14_;
		ESourceOffline* _tmp15_;
		ESourceAuthentication* auth = NULL;
		ESource* _tmp16_;
		ESourceExtension* _tmp17_;
		ESourceAuthentication* _tmp18_;
		CalendarEventStore* calmodel = NULL;
		CalendarEventStore* _tmp51_;
		ESourceRegistry* registry = NULL;
		CalendarEventStore* _tmp52_;
		ESourceRegistry* _tmp53_;
		ESourceRegistry* _tmp54_;
		ESourceRegistry* _tmp55_;
		GList* list = NULL;
		ESource* _tmp56_;
		ESource* _tmp57_;
		ESourceRegistry* _tmp58_;
		GList* _tmp59_;
		CalendarEventStore* _tmp60_;
		ESource* _tmp61_;
#line 68 "../plugins/Google/GoogleBackend.vala"
		_tmp0_ = e_source_new (NULL, NULL, &_inner_error0_);
#line 68 "../plugins/Google/GoogleBackend.vala"
		new_source = _tmp0_;
#line 68 "../plugins/Google/GoogleBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 381 "GoogleBackend.c"
			goto __catch0_g_error;
		}
#line 69 "../plugins/Google/GoogleBackend.vala"
		_tmp1_ = new_source;
#line 69 "../plugins/Google/GoogleBackend.vala"
		e_source_set_display_name (_tmp1_, name);
#line 70 "../plugins/Google/GoogleBackend.vala"
		_tmp2_ = new_source;
#line 70 "../plugins/Google/GoogleBackend.vala"
		_tmp3_ = maya_backend_get_uid ((MayaBackend*) self);
#line 70 "../plugins/Google/GoogleBackend.vala"
		_tmp4_ = _tmp3_;
#line 70 "../plugins/Google/GoogleBackend.vala"
		e_source_set_parent (_tmp2_, _tmp4_);
#line 70 "../plugins/Google/GoogleBackend.vala"
		_g_free0 (_tmp4_);
#line 71 "../plugins/Google/GoogleBackend.vala"
		_tmp5_ = new_source;
#line 71 "../plugins/Google/GoogleBackend.vala"
		_tmp6_ = e_source_get_extension (_tmp5_, E_SOURCE_EXTENSION_CALENDAR);
#line 71 "../plugins/Google/GoogleBackend.vala"
		_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, e_source_calendar_get_type (), ESourceCalendar));
#line 71 "../plugins/Google/GoogleBackend.vala"
		cal = _tmp7_;
#line 72 "../plugins/Google/GoogleBackend.vala"
		_tmp8_ = cal;
#line 72 "../plugins/Google/GoogleBackend.vala"
		e_source_selectable_set_color ((ESourceSelectable*) _tmp8_, color);
#line 73 "../plugins/Google/GoogleBackend.vala"
		_tmp9_ = cal;
#line 73 "../plugins/Google/GoogleBackend.vala"
		e_source_backend_set_backend_name ((ESourceBackend*) _tmp9_, "caldav");
#line 74 "../plugins/Google/GoogleBackend.vala"
		_tmp10_ = new_source;
#line 74 "../plugins/Google/GoogleBackend.vala"
		_tmp11_ = e_source_get_extension (_tmp10_, E_SOURCE_EXTENSION_WEBDAV_BACKEND);
#line 74 "../plugins/Google/GoogleBackend.vala"
		_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, e_source_webdav_get_type (), ESourceWebdav));
#line 74 "../plugins/Google/GoogleBackend.vala"
		webdav = _tmp12_;
#line 75 "../plugins/Google/GoogleBackend.vala"
		_tmp13_ = new_source;
#line 75 "../plugins/Google/GoogleBackend.vala"
		_tmp14_ = e_source_get_extension (_tmp13_, E_SOURCE_EXTENSION_OFFLINE);
#line 75 "../plugins/Google/GoogleBackend.vala"
		_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, e_source_offline_get_type (), ESourceOffline));
#line 75 "../plugins/Google/GoogleBackend.vala"
		offline = _tmp15_;
#line 76 "../plugins/Google/GoogleBackend.vala"
		_tmp16_ = new_source;
#line 76 "../plugins/Google/GoogleBackend.vala"
		_tmp17_ = e_source_get_extension (_tmp16_, E_SOURCE_EXTENSION_AUTHENTICATION);
#line 76 "../plugins/Google/GoogleBackend.vala"
		_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, e_source_authentication_get_type (), ESourceAuthentication));
#line 76 "../plugins/Google/GoogleBackend.vala"
		auth = _tmp18_;
#line 438 "GoogleBackend.c"
		{
			GeeIterator* _widget_it = NULL;
			GeeIterator* _tmp19_;
#line 77 "../plugins/Google/GoogleBackend.vala"
			_tmp19_ = gee_iterable_iterator ((GeeIterable*) widgets);
#line 77 "../plugins/Google/GoogleBackend.vala"
			_widget_it = _tmp19_;
#line 77 "../plugins/Google/GoogleBackend.vala"
			while (TRUE) {
#line 448 "GoogleBackend.c"
				GeeIterator* _tmp20_;
				MayaPlacementWidget* widget = NULL;
				GeeIterator* _tmp21_;
				gpointer _tmp22_;
				MayaPlacementWidget* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp25_;
				GQuark _tmp27_ = 0U;
#line 78 "../plugins/Google/GoogleBackend.vala"
				static GQuark _tmp26_label0 = 0;
#line 78 "../plugins/Google/GoogleBackend.vala"
				static GQuark _tmp26_label1 = 0;
#line 77 "../plugins/Google/GoogleBackend.vala"
				_tmp20_ = _widget_it;
#line 77 "../plugins/Google/GoogleBackend.vala"
				if (!gee_iterator_next (_tmp20_)) {
#line 77 "../plugins/Google/GoogleBackend.vala"
					break;
#line 467 "GoogleBackend.c"
				}
#line 77 "../plugins/Google/GoogleBackend.vala"
				_tmp21_ = _widget_it;
#line 77 "../plugins/Google/GoogleBackend.vala"
				_tmp22_ = gee_iterator_get (_tmp21_);
#line 77 "../plugins/Google/GoogleBackend.vala"
				widget = (MayaPlacementWidget*) _tmp22_;
#line 78 "../plugins/Google/GoogleBackend.vala"
				_tmp23_ = widget;
#line 78 "../plugins/Google/GoogleBackend.vala"
				_tmp24_ = _tmp23_->ref_name;
#line 78 "../plugins/Google/GoogleBackend.vala"
				_tmp25_ = _tmp24_;
#line 78 "../plugins/Google/GoogleBackend.vala"
				_tmp27_ = (NULL == _tmp25_) ? 0 : g_quark_from_string (_tmp25_);
#line 78 "../plugins/Google/GoogleBackend.vala"
				if (_tmp27_ == ((0 != _tmp26_label0) ? _tmp26_label0 : (_tmp26_label0 = g_quark_from_static_string ("user_entry")))) {
#line 78 "../plugins/Google/GoogleBackend.vala"
					switch (0) {
#line 487 "GoogleBackend.c"
						default:
						{
							gchar* decoded_user = NULL;
							MayaPlacementWidget* _tmp28_;
							GtkWidget* _tmp29_;
							const gchar* _tmp30_;
							const gchar* _tmp31_;
							gchar* _tmp32_;
							gboolean _tmp33_ = FALSE;
							const gchar* _tmp34_;
							ESourceAuthentication* _tmp38_;
							const gchar* _tmp39_;
							ESourceWebdav* _tmp40_;
							const gchar* _tmp41_;
							gchar* _tmp42_;
							gchar* _tmp43_;
							GUri* _tmp44_;
							GUri* _tmp45_;
#line 80 "../plugins/Google/GoogleBackend.vala"
							_tmp28_ = widget;
#line 80 "../plugins/Google/GoogleBackend.vala"
							_tmp29_ = _tmp28_->widget;
#line 80 "../plugins/Google/GoogleBackend.vala"
							_tmp30_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_entry_get_type (), GtkEntry));
#line 80 "../plugins/Google/GoogleBackend.vala"
							_tmp31_ = _tmp30_;
#line 80 "../plugins/Google/GoogleBackend.vala"
							_tmp32_ = g_strdup (_tmp31_);
#line 80 "../plugins/Google/GoogleBackend.vala"
							decoded_user = _tmp32_;
#line 81 "../plugins/Google/GoogleBackend.vala"
							_tmp34_ = decoded_user;
#line 81 "../plugins/Google/GoogleBackend.vala"
							if (!string_contains (_tmp34_, "@")) {
#line 522 "GoogleBackend.c"
								const gchar* _tmp35_;
#line 81 "../plugins/Google/GoogleBackend.vala"
								_tmp35_ = decoded_user;
#line 81 "../plugins/Google/GoogleBackend.vala"
								_tmp33_ = !string_contains (_tmp35_, "%40");
#line 528 "GoogleBackend.c"
							} else {
#line 81 "../plugins/Google/GoogleBackend.vala"
								_tmp33_ = FALSE;
#line 532 "GoogleBackend.c"
							}
#line 81 "../plugins/Google/GoogleBackend.vala"
							if (_tmp33_) {
#line 536 "GoogleBackend.c"
								const gchar* _tmp36_;
								gchar* _tmp37_;
#line 82 "../plugins/Google/GoogleBackend.vala"
								_tmp36_ = decoded_user;
#line 82 "../plugins/Google/GoogleBackend.vala"
								_tmp37_ = g_strdup_printf ("%s@gmail.com", _tmp36_);
#line 82 "../plugins/Google/GoogleBackend.vala"
								_g_free0 (decoded_user);
#line 82 "../plugins/Google/GoogleBackend.vala"
								decoded_user = _tmp37_;
#line 547 "GoogleBackend.c"
							}
#line 85 "../plugins/Google/GoogleBackend.vala"
							_tmp38_ = auth;
#line 85 "../plugins/Google/GoogleBackend.vala"
							_tmp39_ = decoded_user;
#line 85 "../plugins/Google/GoogleBackend.vala"
							e_source_authentication_set_user (_tmp38_, _tmp39_);
#line 87 "../plugins/Google/GoogleBackend.vala"
							_tmp40_ = webdav;
#line 87 "../plugins/Google/GoogleBackend.vala"
							_tmp41_ = decoded_user;
#line 87 "../plugins/Google/GoogleBackend.vala"
							_tmp42_ = g_strdup_printf ("/calendar/dav/%s/events", _tmp41_);
#line 87 "../plugins/Google/GoogleBackend.vala"
							_tmp43_ = _tmp42_;
#line 87 "../plugins/Google/GoogleBackend.vala"
							_tmp44_ = g_uri_build (G_URI_FLAGS_NONE, "https", NULL, "www.google.com", -1, _tmp43_, NULL, NULL);
#line 87 "../plugins/Google/GoogleBackend.vala"
							_tmp45_ = _tmp44_;
#line 87 "../plugins/Google/GoogleBackend.vala"
							g_object_set (_tmp40_, "uri", _tmp45_, NULL);
#line 87 "../plugins/Google/GoogleBackend.vala"
							_g_uri_unref0 (_tmp45_);
#line 87 "../plugins/Google/GoogleBackend.vala"
							_g_free0 (_tmp43_);
#line 105 "../plugins/Google/GoogleBackend.vala"
							_g_free0 (decoded_user);
#line 105 "../plugins/Google/GoogleBackend.vala"
							break;
#line 577 "GoogleBackend.c"
						}
					}
				} else if (_tmp27_ == ((0 != _tmp26_label1) ? _tmp26_label1 : (_tmp26_label1 = g_quark_from_static_string ("keep_copy")))) {
#line 78 "../plugins/Google/GoogleBackend.vala"
					switch (0) {
#line 583 "GoogleBackend.c"
						default:
						{
							ESourceOffline* _tmp46_;
							MayaPlacementWidget* _tmp47_;
							GtkWidget* _tmp48_;
							gboolean _tmp49_;
							gboolean _tmp50_;
#line 107 "../plugins/Google/GoogleBackend.vala"
							_tmp46_ = offline;
#line 107 "../plugins/Google/GoogleBackend.vala"
							_tmp47_ = widget;
#line 107 "../plugins/Google/GoogleBackend.vala"
							_tmp48_ = _tmp47_->widget;
#line 107 "../plugins/Google/GoogleBackend.vala"
							_tmp49_ = gtk_toggle_button_get_active ((GtkToggleButton*) G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, gtk_check_button_get_type (), GtkCheckButton));
#line 107 "../plugins/Google/GoogleBackend.vala"
							_tmp50_ = _tmp49_;
#line 107 "../plugins/Google/GoogleBackend.vala"
							e_source_offline_set_stay_synchronized (_tmp46_, _tmp50_);
#line 108 "../plugins/Google/GoogleBackend.vala"
							break;
#line 605 "GoogleBackend.c"
						}
					}
				}
#line 77 "../plugins/Google/GoogleBackend.vala"
				_g_object_unref0 (widget);
#line 611 "GoogleBackend.c"
			}
#line 77 "../plugins/Google/GoogleBackend.vala"
			_g_object_unref0 (_widget_it);
#line 615 "GoogleBackend.c"
		}
#line 112 "../plugins/Google/GoogleBackend.vala"
		_tmp51_ = calendar_event_store_get_default ();
#line 112 "../plugins/Google/GoogleBackend.vala"
		calmodel = _tmp51_;
#line 113 "../plugins/Google/GoogleBackend.vala"
		_tmp52_ = calmodel;
#line 113 "../plugins/Google/GoogleBackend.vala"
		_tmp53_ = calendar_event_store_get_registry (_tmp52_);
#line 113 "../plugins/Google/GoogleBackend.vala"
		_tmp54_ = _tmp53_;
#line 113 "../plugins/Google/GoogleBackend.vala"
		_tmp55_ = _g_object_ref0 (_tmp54_);
#line 113 "../plugins/Google/GoogleBackend.vala"
		registry = _tmp55_;
#line 114 "../plugins/Google/GoogleBackend.vala"
		list = NULL;
#line 115 "../plugins/Google/GoogleBackend.vala"
		_tmp56_ = new_source;
#line 115 "../plugins/Google/GoogleBackend.vala"
		_tmp57_ = _g_object_ref0 (_tmp56_);
#line 115 "../plugins/Google/GoogleBackend.vala"
		list = g_list_append (list, _tmp57_);
#line 116 "../plugins/Google/GoogleBackend.vala"
		_tmp58_ = registry;
#line 116 "../plugins/Google/GoogleBackend.vala"
		_tmp59_ = list;
#line 116 "../plugins/Google/GoogleBackend.vala"
		e_source_registry_create_sources_sync (_tmp58_, _tmp59_, NULL, &_inner_error0_);
#line 116 "../plugins/Google/GoogleBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../plugins/Google/GoogleBackend.vala"
			(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 116 "../plugins/Google/GoogleBackend.vala"
			_g_object_unref0 (registry);
#line 116 "../plugins/Google/GoogleBackend.vala"
			_g_object_unref0 (calmodel);
#line 116 "../plugins/Google/GoogleBackend.vala"
			_g_object_unref0 (auth);
#line 116 "../plugins/Google/GoogleBackend.vala"
			_g_object_unref0 (offline);
#line 116 "../plugins/Google/GoogleBackend.vala"
			_g_object_unref0 (webdav);
#line 116 "../plugins/Google/GoogleBackend.vala"
			_g_object_unref0 (cal);
#line 116 "../plugins/Google/GoogleBackend.vala"
			_g_object_unref0 (new_source);
#line 663 "GoogleBackend.c"
			goto __catch0_g_error;
		}
#line 117 "../plugins/Google/GoogleBackend.vala"
		_tmp60_ = calmodel;
#line 117 "../plugins/Google/GoogleBackend.vala"
		_tmp61_ = new_source;
#line 117 "../plugins/Google/GoogleBackend.vala"
		calendar_event_store_add_source (_tmp60_, _tmp61_);
#line 118 "../plugins/Google/GoogleBackend.vala"
		if (set_default) {
#line 674 "GoogleBackend.c"
			ESourceRegistry* _tmp62_;
			ESource* _tmp63_;
#line 119 "../plugins/Google/GoogleBackend.vala"
			_tmp62_ = registry;
#line 119 "../plugins/Google/GoogleBackend.vala"
			_tmp63_ = new_source;
#line 119 "../plugins/Google/GoogleBackend.vala"
			g_object_set (_tmp62_, "default-calendar", _tmp63_, NULL);
#line 683 "GoogleBackend.c"
		}
#line 67 "../plugins/Google/GoogleBackend.vala"
		(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 67 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (registry);
#line 67 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (calmodel);
#line 67 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (auth);
#line 67 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (offline);
#line 67 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (webdav);
#line 67 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (cal);
#line 67 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (new_source);
#line 701 "GoogleBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp64_;
		const gchar* _tmp65_;
#line 67 "../plugins/Google/GoogleBackend.vala"
		_error_ = _inner_error0_;
#line 67 "../plugins/Google/GoogleBackend.vala"
		_inner_error0_ = NULL;
#line 123 "../plugins/Google/GoogleBackend.vala"
		_tmp64_ = _error_;
#line 123 "../plugins/Google/GoogleBackend.vala"
		_tmp65_ = _tmp64_->message;
#line 123 "../plugins/Google/GoogleBackend.vala"
		g_critical ("GoogleBackend.vala:123: %s", _tmp65_);
#line 67 "../plugins/Google/GoogleBackend.vala"
		_g_error_free0 (_error_);
#line 721 "GoogleBackend.c"
	}
	__finally0:
#line 67 "../plugins/Google/GoogleBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 67 "../plugins/Google/GoogleBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 67 "../plugins/Google/GoogleBackend.vala"
		g_clear_error (&_inner_error0_);
#line 67 "../plugins/Google/GoogleBackend.vala"
		return;
#line 732 "GoogleBackend.c"
	}
}

static void
maya_google_backend_real_modify_calendar (MayaBackend* base,
                                          const gchar* name,
                                          const gchar* color,
                                          gboolean set_default,
                                          GeeCollection* widgets,
                                          ESource* source)
{
	MayaGoogleBackend * self;
	GError* _inner_error0_ = NULL;
#line 127 "../plugins/Google/GoogleBackend.vala"
	self = (MayaGoogleBackend*) base;
#line 127 "../plugins/Google/GoogleBackend.vala"
	g_return_if_fail (name != NULL);
#line 127 "../plugins/Google/GoogleBackend.vala"
	g_return_if_fail (color != NULL);
#line 127 "../plugins/Google/GoogleBackend.vala"
	g_return_if_fail (widgets != NULL);
#line 127 "../plugins/Google/GoogleBackend.vala"
	g_return_if_fail (source != NULL);
#line 756 "GoogleBackend.c"
	{
		ESourceCalendar* cal = NULL;
		ESourceExtension* _tmp0_;
		ESourceCalendar* _tmp1_;
		ESourceCalendar* _tmp2_;
		ESourceWebdav* webdav = NULL;
		ESourceExtension* _tmp3_;
		ESourceWebdav* _tmp4_;
		ESourceOffline* offline = NULL;
		ESourceExtension* _tmp5_;
		ESourceOffline* _tmp6_;
		ESourceAuthentication* auth = NULL;
		ESourceExtension* _tmp7_;
		ESourceAuthentication* _tmp8_;
#line 129 "../plugins/Google/GoogleBackend.vala"
		e_source_set_display_name (source, name);
#line 130 "../plugins/Google/GoogleBackend.vala"
		_tmp0_ = e_source_get_extension (source, E_SOURCE_EXTENSION_CALENDAR);
#line 130 "../plugins/Google/GoogleBackend.vala"
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, e_source_calendar_get_type (), ESourceCalendar));
#line 130 "../plugins/Google/GoogleBackend.vala"
		cal = _tmp1_;
#line 131 "../plugins/Google/GoogleBackend.vala"
		_tmp2_ = cal;
#line 131 "../plugins/Google/GoogleBackend.vala"
		e_source_selectable_set_color ((ESourceSelectable*) _tmp2_, color);
#line 132 "../plugins/Google/GoogleBackend.vala"
		_tmp3_ = e_source_get_extension (source, E_SOURCE_EXTENSION_WEBDAV_BACKEND);
#line 132 "../plugins/Google/GoogleBackend.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, e_source_webdav_get_type (), ESourceWebdav));
#line 132 "../plugins/Google/GoogleBackend.vala"
		webdav = _tmp4_;
#line 133 "../plugins/Google/GoogleBackend.vala"
		_tmp5_ = e_source_get_extension (source, E_SOURCE_EXTENSION_OFFLINE);
#line 133 "../plugins/Google/GoogleBackend.vala"
		_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, e_source_offline_get_type (), ESourceOffline));
#line 133 "../plugins/Google/GoogleBackend.vala"
		offline = _tmp6_;
#line 134 "../plugins/Google/GoogleBackend.vala"
		_tmp7_ = e_source_get_extension (source, E_SOURCE_EXTENSION_AUTHENTICATION);
#line 134 "../plugins/Google/GoogleBackend.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, e_source_authentication_get_type (), ESourceAuthentication));
#line 134 "../plugins/Google/GoogleBackend.vala"
		auth = _tmp8_;
#line 801 "GoogleBackend.c"
		{
			GeeIterator* _widget_it = NULL;
			GeeIterator* _tmp9_;
#line 135 "../plugins/Google/GoogleBackend.vala"
			_tmp9_ = gee_iterable_iterator ((GeeIterable*) widgets);
#line 135 "../plugins/Google/GoogleBackend.vala"
			_widget_it = _tmp9_;
#line 135 "../plugins/Google/GoogleBackend.vala"
			while (TRUE) {
#line 811 "GoogleBackend.c"
				GeeIterator* _tmp10_;
				MayaPlacementWidget* widget = NULL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				MayaPlacementWidget* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				GQuark _tmp17_ = 0U;
#line 136 "../plugins/Google/GoogleBackend.vala"
				static GQuark _tmp16_label0 = 0;
#line 136 "../plugins/Google/GoogleBackend.vala"
				static GQuark _tmp16_label1 = 0;
#line 135 "../plugins/Google/GoogleBackend.vala"
				_tmp10_ = _widget_it;
#line 135 "../plugins/Google/GoogleBackend.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 135 "../plugins/Google/GoogleBackend.vala"
					break;
#line 830 "GoogleBackend.c"
				}
#line 135 "../plugins/Google/GoogleBackend.vala"
				_tmp11_ = _widget_it;
#line 135 "../plugins/Google/GoogleBackend.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 135 "../plugins/Google/GoogleBackend.vala"
				widget = (MayaPlacementWidget*) _tmp12_;
#line 136 "../plugins/Google/GoogleBackend.vala"
				_tmp13_ = widget;
#line 136 "../plugins/Google/GoogleBackend.vala"
				_tmp14_ = _tmp13_->ref_name;
#line 136 "../plugins/Google/GoogleBackend.vala"
				_tmp15_ = _tmp14_;
#line 136 "../plugins/Google/GoogleBackend.vala"
				_tmp17_ = (NULL == _tmp15_) ? 0 : g_quark_from_string (_tmp15_);
#line 136 "../plugins/Google/GoogleBackend.vala"
				if (_tmp17_ == ((0 != _tmp16_label0) ? _tmp16_label0 : (_tmp16_label0 = g_quark_from_static_string ("user_entry")))) {
#line 136 "../plugins/Google/GoogleBackend.vala"
					switch (0) {
#line 850 "GoogleBackend.c"
						default:
						{
							gchar* decoded_user = NULL;
							MayaPlacementWidget* _tmp18_;
							GtkWidget* _tmp19_;
							const gchar* _tmp20_;
							const gchar* _tmp21_;
							gchar* _tmp22_;
							gboolean _tmp23_ = FALSE;
							const gchar* _tmp24_;
							ESourceAuthentication* _tmp28_;
							const gchar* _tmp29_;
							ESourceWebdav* _tmp30_;
							const gchar* _tmp31_;
							gchar* _tmp32_;
							gchar* _tmp33_;
							GUri* _tmp34_;
							GUri* _tmp35_;
#line 138 "../plugins/Google/GoogleBackend.vala"
							_tmp18_ = widget;
#line 138 "../plugins/Google/GoogleBackend.vala"
							_tmp19_ = _tmp18_->widget;
#line 138 "../plugins/Google/GoogleBackend.vala"
							_tmp20_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_entry_get_type (), GtkEntry));
#line 138 "../plugins/Google/GoogleBackend.vala"
							_tmp21_ = _tmp20_;
#line 138 "../plugins/Google/GoogleBackend.vala"
							_tmp22_ = g_strdup (_tmp21_);
#line 138 "../plugins/Google/GoogleBackend.vala"
							decoded_user = _tmp22_;
#line 139 "../plugins/Google/GoogleBackend.vala"
							_tmp24_ = decoded_user;
#line 139 "../plugins/Google/GoogleBackend.vala"
							if (!string_contains (_tmp24_, "@")) {
#line 885 "GoogleBackend.c"
								const gchar* _tmp25_;
#line 139 "../plugins/Google/GoogleBackend.vala"
								_tmp25_ = decoded_user;
#line 139 "../plugins/Google/GoogleBackend.vala"
								_tmp23_ = !string_contains (_tmp25_, "%40");
#line 891 "GoogleBackend.c"
							} else {
#line 139 "../plugins/Google/GoogleBackend.vala"
								_tmp23_ = FALSE;
#line 895 "GoogleBackend.c"
							}
#line 139 "../plugins/Google/GoogleBackend.vala"
							if (_tmp23_) {
#line 899 "GoogleBackend.c"
								const gchar* _tmp26_;
								gchar* _tmp27_;
#line 140 "../plugins/Google/GoogleBackend.vala"
								_tmp26_ = decoded_user;
#line 140 "../plugins/Google/GoogleBackend.vala"
								_tmp27_ = g_strdup_printf ("%s@gmail.com", _tmp26_);
#line 140 "../plugins/Google/GoogleBackend.vala"
								_g_free0 (decoded_user);
#line 140 "../plugins/Google/GoogleBackend.vala"
								decoded_user = _tmp27_;
#line 910 "GoogleBackend.c"
							}
#line 143 "../plugins/Google/GoogleBackend.vala"
							_tmp28_ = auth;
#line 143 "../plugins/Google/GoogleBackend.vala"
							_tmp29_ = decoded_user;
#line 143 "../plugins/Google/GoogleBackend.vala"
							e_source_authentication_set_user (_tmp28_, _tmp29_);
#line 145 "../plugins/Google/GoogleBackend.vala"
							_tmp30_ = webdav;
#line 145 "../plugins/Google/GoogleBackend.vala"
							_tmp31_ = decoded_user;
#line 145 "../plugins/Google/GoogleBackend.vala"
							_tmp32_ = g_strdup_printf ("/calendar/dav/%s/events", _tmp31_);
#line 145 "../plugins/Google/GoogleBackend.vala"
							_tmp33_ = _tmp32_;
#line 145 "../plugins/Google/GoogleBackend.vala"
							_tmp34_ = g_uri_build (G_URI_FLAGS_NONE, "https", NULL, "www.google.com", -1, _tmp33_, NULL, NULL);
#line 145 "../plugins/Google/GoogleBackend.vala"
							_tmp35_ = _tmp34_;
#line 145 "../plugins/Google/GoogleBackend.vala"
							g_object_set (_tmp30_, "uri", _tmp35_, NULL);
#line 145 "../plugins/Google/GoogleBackend.vala"
							_g_uri_unref0 (_tmp35_);
#line 145 "../plugins/Google/GoogleBackend.vala"
							_g_free0 (_tmp33_);
#line 163 "../plugins/Google/GoogleBackend.vala"
							_g_free0 (decoded_user);
#line 163 "../plugins/Google/GoogleBackend.vala"
							break;
#line 940 "GoogleBackend.c"
						}
					}
				} else if (_tmp17_ == ((0 != _tmp16_label1) ? _tmp16_label1 : (_tmp16_label1 = g_quark_from_static_string ("keep_copy")))) {
#line 136 "../plugins/Google/GoogleBackend.vala"
					switch (0) {
#line 946 "GoogleBackend.c"
						default:
						{
							ESourceOffline* _tmp36_;
							MayaPlacementWidget* _tmp37_;
							GtkWidget* _tmp38_;
							gboolean _tmp39_;
							gboolean _tmp40_;
#line 165 "../plugins/Google/GoogleBackend.vala"
							_tmp36_ = offline;
#line 165 "../plugins/Google/GoogleBackend.vala"
							_tmp37_ = widget;
#line 165 "../plugins/Google/GoogleBackend.vala"
							_tmp38_ = _tmp37_->widget;
#line 165 "../plugins/Google/GoogleBackend.vala"
							_tmp39_ = gtk_toggle_button_get_active ((GtkToggleButton*) G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, gtk_check_button_get_type (), GtkCheckButton));
#line 165 "../plugins/Google/GoogleBackend.vala"
							_tmp40_ = _tmp39_;
#line 165 "../plugins/Google/GoogleBackend.vala"
							e_source_offline_set_stay_synchronized (_tmp36_, _tmp40_);
#line 166 "../plugins/Google/GoogleBackend.vala"
							break;
#line 968 "GoogleBackend.c"
						}
					}
				}
#line 135 "../plugins/Google/GoogleBackend.vala"
				_g_object_unref0 (widget);
#line 974 "GoogleBackend.c"
			}
#line 135 "../plugins/Google/GoogleBackend.vala"
			_g_object_unref0 (_widget_it);
#line 978 "GoogleBackend.c"
		}
#line 170 "../plugins/Google/GoogleBackend.vala"
		e_source_write (source, NULL, NULL, NULL);
#line 171 "../plugins/Google/GoogleBackend.vala"
		if (set_default) {
#line 984 "GoogleBackend.c"
			ESourceRegistry* registry = NULL;
			ESourceRegistry* _tmp41_;
			ESourceRegistry* _tmp42_;
#line 172 "../plugins/Google/GoogleBackend.vala"
			_tmp41_ = e_source_registry_new_sync (NULL, &_inner_error0_);
#line 172 "../plugins/Google/GoogleBackend.vala"
			registry = _tmp41_;
#line 172 "../plugins/Google/GoogleBackend.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../plugins/Google/GoogleBackend.vala"
				_g_object_unref0 (auth);
#line 172 "../plugins/Google/GoogleBackend.vala"
				_g_object_unref0 (offline);
#line 172 "../plugins/Google/GoogleBackend.vala"
				_g_object_unref0 (webdav);
#line 172 "../plugins/Google/GoogleBackend.vala"
				_g_object_unref0 (cal);
#line 1002 "GoogleBackend.c"
				goto __catch0_g_error;
			}
#line 173 "../plugins/Google/GoogleBackend.vala"
			_tmp42_ = registry;
#line 173 "../plugins/Google/GoogleBackend.vala"
			g_object_set (_tmp42_, "default-calendar", source, NULL);
#line 171 "../plugins/Google/GoogleBackend.vala"
			_g_object_unref0 (registry);
#line 1011 "GoogleBackend.c"
		}
#line 128 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (auth);
#line 128 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (offline);
#line 128 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (webdav);
#line 128 "../plugins/Google/GoogleBackend.vala"
		_g_object_unref0 (cal);
#line 1021 "GoogleBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp43_;
		const gchar* _tmp44_;
#line 128 "../plugins/Google/GoogleBackend.vala"
		_error_ = _inner_error0_;
#line 128 "../plugins/Google/GoogleBackend.vala"
		_inner_error0_ = NULL;
#line 177 "../plugins/Google/GoogleBackend.vala"
		_tmp43_ = _error_;
#line 177 "../plugins/Google/GoogleBackend.vala"
		_tmp44_ = _tmp43_->message;
#line 177 "../plugins/Google/GoogleBackend.vala"
		g_critical ("GoogleBackend.vala:177: %s", _tmp44_);
#line 128 "../plugins/Google/GoogleBackend.vala"
		_g_error_free0 (_error_);
#line 1041 "GoogleBackend.c"
	}
	__finally0:
#line 128 "../plugins/Google/GoogleBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 128 "../plugins/Google/GoogleBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 128 "../plugins/Google/GoogleBackend.vala"
		g_clear_error (&_inner_error0_);
#line 128 "../plugins/Google/GoogleBackend.vala"
		return;
#line 1052 "GoogleBackend.c"
	}
}

static void
maya_google_backend_class_init (MayaGoogleBackendClass * klass,
                                gpointer klass_data)
{
#line 32 "../plugins/Google/GoogleBackend.vala"
	maya_google_backend_parent_class = g_type_class_peek_parent (klass);
#line 1062 "GoogleBackend.c"
}

static void
maya_google_backend_maya_backend_interface_init (MayaBackendIface * iface,
                                                 gpointer iface_data)
{
#line 32 "../plugins/Google/GoogleBackend.vala"
	maya_google_backend_maya_backend_parent_iface = g_type_interface_peek_parent (iface);
#line 32 "../plugins/Google/GoogleBackend.vala"
	iface->get_name = (gchar* (*) (MayaBackend*)) maya_google_backend_real_get_name;
#line 32 "../plugins/Google/GoogleBackend.vala"
	iface->get_uid = (gchar* (*) (MayaBackend*)) maya_google_backend_real_get_uid;
#line 32 "../plugins/Google/GoogleBackend.vala"
	iface->get_new_calendar_widget = (GeeCollection* (*) (MayaBackend*, ESource*)) maya_google_backend_real_get_new_calendar_widget;
#line 32 "../plugins/Google/GoogleBackend.vala"
	iface->add_new_calendar = (void (*) (MayaBackend*, const gchar*, const gchar*, gboolean, GeeCollection*)) maya_google_backend_real_add_new_calendar;
#line 32 "../plugins/Google/GoogleBackend.vala"
	iface->modify_calendar = (void (*) (MayaBackend*, const gchar*, const gchar*, gboolean, GeeCollection*, ESource*)) maya_google_backend_real_modify_calendar;
#line 1081 "GoogleBackend.c"
}

static void
maya_google_backend_instance_init (MayaGoogleBackend * self,
                                   gpointer klass)
{
}

static GType
maya_google_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MayaGoogleBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) maya_google_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MayaGoogleBackend), 0, (GInstanceInitFunc) maya_google_backend_instance_init, NULL };
	static const GInterfaceInfo maya_backend_info = { (GInterfaceInitFunc) maya_google_backend_maya_backend_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType maya_google_backend_type_id;
	maya_google_backend_type_id = g_type_register_static (G_TYPE_OBJECT, "MayaGoogleBackend", &g_define_type_info, 0);
	g_type_add_interface_static (maya_google_backend_type_id, MAYA_TYPE_BACKEND, &maya_backend_info);
	return maya_google_backend_type_id;
}

GType
maya_google_backend_get_type (void)
{
	static volatile gsize maya_google_backend_type_id__once = 0;
	if (g_once_init_enter (&maya_google_backend_type_id__once)) {
		GType maya_google_backend_type_id;
		maya_google_backend_type_id = maya_google_backend_get_type_once ();
		g_once_init_leave (&maya_google_backend_type_id__once, maya_google_backend_type_id);
	}
	return maya_google_backend_type_id__once;
}

